var UpdateChecker = {
	checking: false,
	checkList: null,
	httpReq: null,
	lastResource: null,
	httpReqTimer: null,  //
	refreshCount: false, // Added by Higmmer
	foundFeeds: 0,       //

	/*getURL: function(resuorce) { // Removed by Higmmer
		return _impl.getUrl(resource); // Modified by Higmmer
	},*/

	startCheck: function(aCheckFolderId, aSkipCheck) {
		if(this.checking) return;

		// Added by Higmmer (inspired by Sage-Too)
		this.refreshCount = CommonFunc.getPrefValue(CommonFunc.SHOW_UPDATE_COUNT, "bool", false) && CommonFunc.getPrefValue(CommonFunc.CHECK_UPDATE_RT_REFRESH, "bool", true);
		this.foundFeeds = 0;

		var resourceList = CommonFunc.getBMDSCChildren(aCheckFolderId);
		this.checkList = new Array();

		// select feeds to be checked, exclude separators and updated feeds
		for each(var res in resourceList) { // Modified by Higmmer
			var url = _impl.getUrl(res);
			var status = _impl.getStatus(res);
			if(url && !(status == CommonFunc.STATUS_UPDATE || status == CommonFunc.STATUS_NO_CHECK)) {
				if(aSkipCheck) continue; // Added by Higmmer
				this.checkList.push(res);
			} else if(url && (status == CommonFunc.STATUS_UPDATE)) { // Added by Higmmer
				this.onUpdated(null, res, _impl.getTitle(res), url);
			}
		}

		//logMessage("checking " + this.checkList.length + " feed(s)"); // Removed by Higmmer

		if (this.checkList.length > 0) {
			logMessage("checking " + this.checkList.length + " feed(s)"); // Added by Higmmer
			this.checking = true;
			this.check();
		} else { // Added by Higmmer
			logMessage("checking is skipped");
			this.onChecked(0);
		}
	},

	done: function() {
		this.clearHttpReqTimeout(); // Added by Higmmer
		if(this.checking) {
			this.checking = false;
			this.httpReq.abort();
		}
	},

	check: function() {
		this.clearHttpReqTimeout(); // Added by Higmmer

		this.lastResource = this.checkList.shift();

		// Modified by Higmmer
		this.checkResource(_impl.getTitle(this.lastResource), _impl.getType(this.lastResource), _impl.getUrl(this.lastResource));
	},

	//----- Added by Higmmer : Start ----->
    checkResource: function(name, type, url) { // from Sage-Too
		if(!url) {
			this.checkResult(false, 0);
		}

		if(this.httpReq) {
			this.httpReq.abort();
		}
		
		try {
			this.httpReq = new XMLHttpRequest();
			this.httpReq.parent = this;

			this.httpReq.open("GET", url);

			this.httpReq.onload = this.httpLoaded;
			this.httpReq.onerror = this.httpError;
			this.httpReq.onreadystatechange = this.httpReadyStateChange;

			this.setHttpReqTimeout(); // Added by Higmmer

			this.httpReq.setRequestHeader("User-Agent", USER_AGENT);
			this.httpReq.overrideMimeType("application/xml");
			this.httpReq.send(null);
			this.onCheck(name, url);
		} catch(e) {
			// FAILURE
			this.abort(); // Modified by Higmmer
		}
	},

	// The original code is written by Graham King
	// And special thanks to "Firefox Hacks Translation Diary"
	abort: function() {
		if(UpdateChecker.checking) {
			UpdateChecker.httpReq.abort();
			UpdateChecker.checkResult(false, 0);
		}
	},

	setHttpReqTimeout: function() {
		var timeout = CommonFunc.getPrefValue(CommonFunc.CHECK_UPDATE_TIMEOUT, "int", 10000);
		if(timeout > 0) {
			if(timeout < 1000) timeout = 1000;
			UpdateChecker.httpReqTimer = window.setTimeout(this.httpReqTimeout, timeout);
		}
	},

	clearHttpReqTimeout: function() {
		if(UpdateChecker.httpReqTimer) {
			window.clearTimeout(UpdateChecker.httpReqTimer);
			UpdateChecker.httpReqTimer = null;
		}
	},

	httpReqTimeout: function() {
		logMessage("HTTP request timed out - aborting: " + _impl.getTitle(UpdateChecker.lastResource));
		UpdateChecker.abort();
	},
	//<----- Added by Higmmer : End -----

	httpError: function(e) {
		UpdateChecker.clearHttpReqTimeout(); // Added by Higmmer
		logMessage("HTTP Error: " + e.target.status + " - " + e.target.statusText);
		UpdateChecker.abort(); // Modified by Higmmer
	},

	httpReadyStateChange: function() {
		if(UpdateChecker.httpReq.readyState == 2) {
			try {
				UpdateChecker.httpReq.status;
			} catch(e) {
				// URL NOT AVAILABLE
				UpdateChecker.clearHttpReqTimeout(); // Modified by Higmmer
				UpdateChecker.abort();
			}
		}
	},

	httpLoaded: function(e) {
		//----- Added by Higmmer : Start ----->
		UpdateChecker.clearHttpReqTimeout();

		// (inspired by Sage-Too)
		var location = UpdateChecker.httpReq.getResponseHeader("location");
		if(location) {
			UpdateChecker.checkResource(_impl.getTitle(UpdateChecker.lastResource.title),
			                            _impl.getType(UpdateChecker.lastResource.type),
			                            location);
			return;
		}
		//<----- Added by Higmmer : End -----

		var lastModified = 0;

		try {
			//----- Added by Higmmer : Start ----->
			var feedXML = UpdateChecker.httpReq.responseXML;
			if(UpdateChecker.httpReq.responseXML.documentElement.localName.toLowerCase() == "parsererror") {
				feedXML = tryFixInvalidXml(UpdateChecker.httpReq.responseText, feedXML.xmlEncoding);
			}
			//<----- Added by Higmmer : End -----

			var feed = new Feed(feedXML, _impl.getUrl(UpdateChecker.lastResource)); // Modified by Higmmer
		} catch(e) {
			UpdateChecker.checkResult(false, 0);
			return;
		}

		if(feed.hasLastPubDate()) {
			lastModified = feed.getLastPubDate().getTime();
		}
		
		UpdateChecker.checkResult(true, lastModified, feed);
	},

	checkResult: function(aSucceed, aLastModified, feed) {
		//----- Modified by Higmmer : Start ----->
		var name = _impl.getTitle(this.lastResource);
		var url = _impl.getUrl(this.lastResource);
		var status = "";
		var signature = feed ? feed.getSignature() : ""; // (inspired by Sage-Too)
		//<----- Modified by Higmmer : End -----

		//----- Removed by Higmmer : Start ----->
		/*var lastVisit = _impl.getLastVisit(this.lastResource); // Modified by Higmemr
		if(!lastVisit) {
			lastVisit = 0;
		} else {
			lastVisit /= 1000;
		}*/
		//<----- Removed by Higmmer : End -----

		if(aSucceed) {
			var oldlastModified = _impl.getLastModified(this.lastResource); // Added by Higmmer
			var oldSig = _impl.getSignature(this.lastResource);             // Modified by Higmmer
			var oldStatus = _impl.getStatus(this.lastResource);             // Added by Higmmer (inspired by Sage-Too)

			if(aLastModified) {
				if((aLastModified > oldlastModified) && (oldSig != signature)) { // Modified by Higmmer
					status = CommonFunc.STATUS_UPDATE;
				} else {
					status = CommonFunc.STATUS_NO_UPDATE;
				}
			} else {
				if(oldSig != signature) {
					status = CommonFunc.STATUS_UPDATE;
				} else {
					status = CommonFunc.STATUS_NO_UPDATE;
				}
			}
		} else {
			status = CommonFunc.STATUS_ERROR;
		}

		//----- Modified by Higmmer : Start (inspired by Sage-Too) ----->
		if(status != CommonFunc.STATUS_NO_UPDATE || status != oldStatus) {
			_impl.setStatusAndSignature(this.lastResource, status, signature);
			if(this.refreshCount) UpdateCounter.update(UpdateCounter._getParent(this.lastResource), false, false, true);
			_impl.invalidateAllTreeView(bookmarksTree.view);
		};
		//<----- Modified by Higmmer : End -----

		if(status == CommonFunc.STATUS_UPDATE) { // Added by Higmmer
			this.foundFeeds++;
			this.onUpdated(feed, this.lastResource, name, url);
		}

		if(this.checkList.length == 0) {
			this.checking = false;
			logMessage("checking is done, found " + this.foundFeeds + " feed(s)"); // Added by Higmmer
			this.onChecked(this.foundFeeds); // Modified by Higmmer
			return;
		} else {
			this.check();
		}
	},


	onCheck:   function(aName, aURL) {},
	onChecked: function(aFoundFeeds) {},             // Modified by Higmmer
	onUpdated: function(aFeed, aRes, aName, aURL) {} // Added by Higmmer

}